<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::adsl::DirectiveRouter Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1adsl.html">adsl</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::adsl::DirectiveRouter Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_directive_router_8h_source.html">DirectiveRouter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::adsl::DirectiveRouter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1adsl_1_1_directive_router__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1adsl_1_1_directive_router_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1adsl_1_1_directive_router_inherit__map" id="alexa_client_s_d_k_1_1adsl_1_1_directive_router_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="5,5,202,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::adsl::DirectiveRouter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1adsl_1_1_directive_router__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1adsl_1_1_directive_router_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1adsl_1_1_directive_router_coll__map" id="alexa_client_s_d_k_1_1adsl_1_1_directive_router_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html" title="alexaClientSDK::avsCommon\l::utils::RequiresShutdown" alt="" coords="5,5,202,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a366dfaa6f651ed528ca5ee9f5b2cfc0f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a366dfaa6f651ed528ca5ee9f5b2cfc0f">DirectiveRouter</a> ()</td></tr>
<tr class="memdesc:a366dfaa6f651ed528ca5ee9f5b2cfc0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a366dfaa6f651ed528ca5ee9f5b2cfc0f">More...</a><br /></td></tr>
<tr class="separator:a366dfaa6f651ed528ca5ee9f5b2cfc0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a5fd2b9d8d69b56aa9b21212fad8bc8"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a5a5fd2b9d8d69b56aa9b21212fad8bc8">addDirectiveHandler</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerInterface</a> &gt; handler)</td></tr>
<tr class="separator:a5a5fd2b9d8d69b56aa9b21212fad8bc8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9d36b2f365afebbd8229fa79246350d8"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a9d36b2f365afebbd8229fa79246350d8">removeDirectiveHandler</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerInterface</a> &gt; handler)</td></tr>
<tr class="separator:a9d36b2f365afebbd8229fa79246350d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70013c098467dafafc8f4b2203256d99"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a70013c098467dafafc8f4b2203256d99">handleDirectiveImmediately</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive)</td></tr>
<tr class="separator:a70013c098467dafafc8f4b2203256d99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0df6d0f2e0bf3f5735e8e8342c5539a5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a0df6d0f2e0bf3f5735e8e8342c5539a5">preHandleDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerResultInterface</a> &gt; result)</td></tr>
<tr class="separator:a0df6d0f2e0bf3f5735e8e8342c5539a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9777ef5a1bf81a2ec3988421e1015f48"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a9777ef5a1bf81a2ec3988421e1015f48">handleDirective</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; &amp;directive)</td></tr>
<tr class="separator:a9777ef5a1bf81a2ec3988421e1015f48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a738b6cc84cc4963290b1e75896d84c6f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a738b6cc84cc4963290b1e75896d84c6f">cancelDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive)</td></tr>
<tr class="separator:a738b6cc84cc4963290b1e75896d84c6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1bf47bc5f140e2358a3fde4a17b5d765"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">avsCommon::avs::BlockingPolicy</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a1bf47bc5f140e2358a3fde4a17b5d765">getPolicy</a> (const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; &amp;directive)</td></tr>
<tr class="separator:a1bf47bc5f140e2358a3fde4a17b5d765"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></td></tr>
<tr class="memitem:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#aae7174ed932ae1413460255238c4422b">RequiresShutdown</a> (const std::string &amp;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a>)</td></tr>
<tr class="separator:aae7174ed932ae1413460255238c4422b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">~RequiresShutdown</a> ()</td></tr>
<tr class="memdesc:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a649b80d77e4e6f66e218ee3bfc71823b">More...</a><br /></td></tr>
<tr class="separator:a649b80d77e4e6f66e218ee3bfc71823b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a745cd4dc404db52f7d0afbf838454fac">name</a> () const</td></tr>
<tr class="separator:a745cd4dc404db52f7d0afbf838454fac inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#a350a147e52eb3ad3c1326e6639861066">shutdown</a> ()</td></tr>
<tr class="separator:a350a147e52eb3ad3c1326e6639861066 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html#af9352626109735aba40b5fb310913355">isShutdown</a> () const</td></tr>
<tr class="separator:af9352626109735aba40b5fb310913355 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Class to maintain a mapping from <code>NamespaceAndName</code> to <code>HandlerAndPolicy</code>, and to invoke <code>DirectiveHandlerInterface</code> methods on the <code>DirectiveHandler</code> registered for a given <code>AVSDirective</code>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a366dfaa6f651ed528ca5ee9f5b2cfc0f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a366dfaa6f651ed528ca5ee9f5b2cfc0f">&#9670;&nbsp;</a></span>DirectiveRouter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::adsl::DirectiveRouter::DirectiveRouter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a5a5fd2b9d8d69b56aa9b21212fad8bc8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a5fd2b9d8d69b56aa9b21212fad8bc8">&#9670;&nbsp;</a></span>addDirectiveHandler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::addDirectiveHandler </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Add mappings from from handler's <code>NamespaceAndName</code> values to <code>BlockingPolicy</code> values, gotten through the handler's getConfiguration() method. If a mapping for any of the specified <code>NamespaceAndName</code> values already exists the entire call is refused.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handler</td><td>The handler to add. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the handler was added. </dd></dl>

</div>
</div>
<a id="a738b6cc84cc4963290b1e75896d84c6f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a738b6cc84cc4963290b1e75896d84c6f">&#9670;&nbsp;</a></span>cancelDirective()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::cancelDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Invoke <a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a738b6cc84cc4963290b1e75896d84c6f">cancelDirective()</a> on the handler registered for the given <code>AVSDirective</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to be handled. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether or not the handler was invoked. </dd></dl>

</div>
</div>
<a id="a1bf47bc5f140e2358a3fde4a17b5d765"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1bf47bc5f140e2358a3fde4a17b5d765">&#9670;&nbsp;</a></span>getPolicy()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_blocking_policy.html">BlockingPolicy</a> alexaClientSDK::adsl::DirectiveRouter::getPolicy </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Get the policy associated with the given directive.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive for which the policy is required. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The corresponding <code>BlockingPolicy</code> value for the directive. </dd></dl>

</div>
</div>
<a id="a9777ef5a1bf81a2ec3988421e1015f48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9777ef5a1bf81a2ec3988421e1015f48">&#9670;&nbsp;</a></span>handleDirective()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::handleDirective </td>
          <td>(</td>
          <td class="paramtype">const std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; &amp;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Invoke <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a9777ef5a1bf81a2ec3988421e1015f48">handleDirective()</a></code> on the handler registered for the given <code>AVSDirective</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to be handled. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if the the registered handler returned <code>true</code>. <code>false</code> if there was no registered handler or the registered handler returned <code>false</code> (indicating that the directive was not recognized. </dd></dl>

</div>
</div>
<a id="a70013c098467dafafc8f4b2203256d99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a70013c098467dafafc8f4b2203256d99">&#9670;&nbsp;</a></span>handleDirectiveImmediately()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::handleDirectiveImmediately </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Invoke <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a70013c098467dafafc8f4b2203256d99">handleDirectiveImmediately()</a></code> on the handler registered for the given <code>AVSDirective</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to be handled immediately. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether or not the handler was invoked. </dd></dl>

</div>
</div>
<a id="a0df6d0f2e0bf3f5735e8e8342c5539a5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0df6d0f2e0bf3f5735e8e8342c5539a5">&#9670;&nbsp;</a></span>preHandleDirective()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::preHandleDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_result_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerResultInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>result</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Invoke <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html#a0df6d0f2e0bf3f5735e8e8342c5539a5">preHandleDirective()</a></code> on the handler registered for the given <code>AVSDirective</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The directive to be preHandled. </td></tr>
    <tr><td class="paramname">result</td><td>A result object to receive notification about the completion (or failure) of handling the <code>AVSDirective</code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether or not the handler was invoked. </dd></dl>

</div>
</div>
<a id="a9d36b2f365afebbd8229fa79246350d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9d36b2f365afebbd8229fa79246350d8">&#9670;&nbsp;</a></span>removeDirectiveHandler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveRouter::removeDirectiveHandler </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>handler</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Remove the specified mappings from <code>NamespaceAndName</code> values to <code>BlockingPolicy</code> values, gotten through the handler's getConfiguration() method. If any of the specified mappings do not match an existing mapping, the entire operation is refused.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">handler</td><td>The handler to remove. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the configuration was removed. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ADSL/include/ADSL/<a class="el" href="_directive_router_8h_source.html">DirectiveRouter.h</a></li>
<li>/workplace/avs-device-sdk/ADSL/src/<a class="el" href="_directive_router_8cpp.html">DirectiveRouter.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
